source: configure @ ba7d16f

Last change on this file since ba7d16f was ba7d16f, checked in by Wilmer van der Gaast <wilmer@…>, at 2010-03-24T17:12:53Z

Now seems like a pretty good time to finally kill crypting.c and storage_text.
This means people won't be able to upgrade from BitlBee 1.0 to this version
anymore but only via 1.2.

1.0 is old enough that I don't really expect this to be a problem.

  • Property mode set to 100755
File size: 13.7 KB
Line 
1#!/bin/sh
2
3##############################
4##  Configurer for BitlBee  ##
5##                          ##
6##  Copyright 2004 Lintux   ##
7##  Copyright 2002 Lucumo   ##
8##############################
9
10prefix='/usr/local/'
11bindir='$prefix/sbin/'
12etcdir='$prefix/etc/bitlbee/'
13mandir='$prefix/share/man/'
14datadir='$prefix/share/bitlbee/'
15config='/var/lib/bitlbee/'
16plugindir='$prefix/lib/bitlbee/'
17includedir='$prefix/include/bitlbee/'
18libevent='/usr/'
19pidfile='/var/run/bitlbee.pid'
20ipcsocket='/var/run/bitlbee.sock'
21pcdir='$prefix/lib/pkgconfig'
22systemlibdirs="/lib /lib64 /usr/lib /usr/lib64 /usr/local/lib /usr/local/lib64"
23
24msn=1
25jabber=1
26oscar=1
27yahoo=1
28
29debug=0
30strip=1
31gcov=0
32plugins=1
33
34events=glib
35ldap=0
36ssl=auto
37
38arch=`uname -s`
39cpu=`uname -m`
40
41GLIB_MIN_VERSION=2.4
42
43echo BitlBee configure
44
45while [ -n "$1" ]; do
46        e="`expr "X$1" : 'X--\(.*=.*\)'`"
47        if [ -z "$e" ]; then
48                cat<<EOF
49
50Usage: $0 [OPTIONS]
51
52Option          Description                             Default
53
54--prefix=...    Directories to put files in             $prefix
55--bindir=...                                            $bindir
56--etcdir=...                                            $etcdir
57--mandir=...                                            $mandir
58--datadir=...                                           $datadir
59--plugindir=...                                         $plugindir
60--pidfile=...                                           $pidfile
61--config=...                                            $config
62--ipcsocket=...                                         $ipcsocket
63
64--msn=0/1       Disable/enable MSN part                 $msn
65--jabber=0/1    Disable/enable Jabber part              $jabber
66--oscar=0/1     Disable/enable Oscar part (ICQ, AIM)    $oscar
67--yahoo=0/1     Disable/enable Yahoo part               $yahoo
68
69--debug=0/1     Disable/enable debugging                $debug
70--strip=0/1     Disable/enable binary stripping         $strip
71--gcov=0/1      Disable/enable test coverage reporting  $gcov
72--plugins=0/1   Disable/enable plugins support          $plugins
73
74--events=...    Event handler (glib, libevent)          $events
75--ssl=...       SSL library to use (gnutls, nss, openssl, bogus, auto)
76                                                        $ssl
77
78--target=...    Cross compilation target                same as host
79EOF
80                exit;
81        fi
82        eval "$e"
83        shift;
84done
85
86# Expand $prefix and get rid of double slashes
87bindir=`eval echo "$bindir/" | sed 's/\/\{1,\}/\//g'`
88etcdir=`eval echo "$etcdir/" | sed 's/\/\{1,\}/\//g'`
89mandir=`eval echo "$mandir/" | sed 's/\/\{1,\}/\//g'`
90datadir=`eval echo "$datadir/" | sed 's/\/\{1,\}/\//g'`
91config=`eval echo "$config/" | sed 's/\/\{1,\}/\//g'`
92plugindir=`eval echo "$plugindir/" | sed 's/\/\{1,\}/\//g'`
93includedir=`eval echo "$includedir"/ | sed 's/\/\{1,\}/\//g'`
94libevent=`eval echo "$libevent"/ | sed 's/\/\{1,\}/\//g'`
95
96pidfile=`eval echo "$pidfile" | sed 's/\/\{1,\}/\//g'`
97ipcsocket=`eval echo "$ipcsocket" | sed 's/\/\{1,\}/\//g'`
98pcdir=`eval echo "$pcdir" | sed 's/\/\{1,\}/\//g'`
99
100cat<<EOF>Makefile.settings
101## BitlBee settings, generated by configure
102PREFIX=$prefix
103BINDIR=$bindir
104ETCDIR=$etcdir
105MANDIR=$mandir
106DATADIR=$datadir
107PLUGINDIR=$plugindir
108CONFIG=$config
109INCLUDEDIR=$includedir
110PCDIR=$pcdir
111
112TARGET=$target
113ARCH=$arch
114CPU=$cpu
115
116DESTDIR=
117LFLAGS=
118EFLAGS=
119EOF
120
121cat<<EOF>config.h
122/* BitlBee settings, generated by configure
123   
124   Do *NOT* use any of these defines in your code without thinking twice, most
125   of them can/will be overridden at run-time */
126
127#define CONFIG "$config"
128#define ETCDIR "$etcdir"
129#define VARDIR "$datadir"
130#define PLUGINDIR "$plugindir"
131#define PIDFILE "$pidfile"
132#define IPCSOCKET "$ipcsocket"
133#define ARCH "$arch"
134#define CPU "$cpu"
135EOF
136
137
138
139if [ -n "$target" ]; then
140        PKG_CONFIG_LIBDIR=/usr/$target/lib/pkgconfig
141        export PKG_CONFIG_LIBDIR
142        PATH=/usr/$target/bin:$PATH
143        CC=$target-cc
144        LD=$target-ld
145        systemlibdirs="/usr/$target/lib"
146fi
147
148
149if [ "$debug" = "1" ]; then
150        [ -z "$CFLAGS" ] && CFLAGS=-g
151        echo 'DEBUG=1' >> Makefile.settings
152        CFLAGS="$CFLAGS -DDEBUG"
153else
154        [ -z "$CFLAGS" ] && CFLAGS="-O2 -fno-strict-aliasing"
155fi
156
157echo CFLAGS=$CFLAGS >> Makefile.settings
158echo CFLAGS+=-I`pwd` -I`pwd`/lib -I`pwd`/protocols -I. >> Makefile.settings
159
160echo CFLAGS+=-DHAVE_CONFIG_H >> Makefile.settings
161
162if [ -n "$CC" ]; then
163        CC=$CC
164elif type gcc > /dev/null 2> /dev/null; then
165        CC=gcc
166elif type cc > /dev/null 2> /dev/null; then
167        CC=cc
168else
169        echo 'Cannot find a C compiler, aborting.'
170        exit 1;
171fi
172
173echo "CC=$CC" >> Makefile.settings;
174
175if [ -z "$LD" ]; then
176        if type ld > /dev/null 2> /dev/null; then
177                LD=ld
178        else
179                echo 'Cannot find ld, aborting.'
180                exit 1;
181        fi
182fi
183
184echo "LD=$LD" >> Makefile.settings
185
186if [ -z "$PKG_CONFIG" ]; then
187        PKG_CONFIG=pkg-config
188fi
189
190if $PKG_CONFIG --version > /dev/null 2>/dev/null && $PKG_CONFIG glib-2.0; then
191        if $PKG_CONFIG glib-2.0 --atleast-version=$GLIB_MIN_VERSION; then
192                cat<<EOF>>Makefile.settings
193EFLAGS+=`$PKG_CONFIG --libs glib-2.0 gmodule-2.0`
194CFLAGS+=`$PKG_CONFIG --cflags glib-2.0 gmodule-2.0`
195EOF
196        else
197                echo
198                echo 'Found glib2 '`$PKG_CONFIG glib-2.0 --modversion`', but version '$GLIB_MIN_VERSION' or newer is required.'
199                exit 1
200        fi
201else
202        echo
203        echo 'Cannot find glib2 development libraries, aborting. (Install libglib2-dev?)'
204        exit 1
205fi
206
207if [ "$events" = "libevent" ]; then
208        if ! [ -f "${libevent}include/event.h" ]; then
209                echo
210                echo 'Warning: Could not find event.h, you might have to install it and/or specify'
211                echo 'its location using the --libevent= argument. (Example: If event.h is in'
212                echo '/usr/local/include and binaries are in /usr/local/lib: --libevent=/usr/local)'
213        fi
214       
215        echo '#define EVENTS_LIBEVENT' >> config.h
216        cat <<EOF>>Makefile.settings
217EFLAGS+=-levent -L${libevent}lib
218CFLAGS+=-I${libevent}include
219EOF
220elif [ "$events" = "glib" ]; then
221        ## We already use glib anyway, so this is all we need (and in fact not even this, but just to be sure...):
222        echo '#define EVENTS_GLIB' >> config.h
223else
224        echo
225        echo 'ERROR: Unknown event handler specified.'
226        exit 1
227fi
228echo 'EVENT_HANDLER=events_'$events'.o' >> Makefile.settings
229
230detect_gnutls()
231{
232        if $PKG_CONFIG --exists gnutls; then
233                cat <<EOF>>Makefile.settings
234EFLAGS+=`$PKG_CONFIG --libs gnutls`
235CFLAGS+=`$PKG_CONFIG --cflags gnutls`
236EOF
237                ssl=gnutls
238                ret=1
239        elif libgnutls-config --version > /dev/null 2> /dev/null; then
240                cat <<EOF>>Makefile.settings
241EFLAGS+=`libgnutls-config --libs`
242CFLAGS+=`libgnutls-config --cflags`
243EOF
244               
245                ssl=gnutls
246                ret=1;
247        else
248                ret=0;
249        fi;
250}
251
252detect_nss()
253{
254        if $PKG_CONFIG --version > /dev/null 2>/dev/null && $PKG_CONFIG mozilla-nss; then
255                cat<<EOF>>Makefile.settings
256EFLAGS+=`$PKG_CONFIG --libs mozilla-nss`
257CFLAGS+=`$PKG_CONFIG --cflags mozilla-nss`
258EOF
259               
260                ssl=nss
261                ret=1;
262        else
263                ret=0;
264        fi;
265}
266
267detect_ldap()
268{
269        TMPFILE=$(mktemp)
270        if $CC -o $TMPFILE -shared -lldap 2>/dev/null >/dev/null; then
271                cat<<EOF>>Makefile.settings
272EFLAGS+=-lldap
273CFLAGS+=
274EOF
275                ldap=1
276                rm -f $TMPFILE
277                ret=1
278        else
279                ldap=0
280                ret=0
281        fi
282}
283
284RESOLV_TESTCODE='
285#include <arpa/nameser.h>
286#include <resolv.h>
287
288int main()
289{
290        ns_initparse( NULL, 0, NULL );
291        ns_parserr( NULL, ns_s_an, 0, NULL );
292}
293'
294
295detect_resolv_dynamic()
296{
297        TMPFILE=$(mktemp)
298        ret=1
299        echo "$RESOLV_TESTCODE" | $CC -o $TMPFILE -x c - -lresolv >/dev/null 2>/dev/null
300        if [ "$?" = "0" ]; then
301                echo 'EFLAGS+=-lresolv' >> Makefile.settings
302                ret=0
303        fi
304
305        rm -f $TMPFILE
306        return $ret
307}
308
309detect_resolv_static()
310{
311        TMPFILE=$(mktemp)
312        ret=1
313        for i in $systemlibdirs; do
314                if [ -f $i/libresolv.a ]; then
315                        echo "$RESOLV_TESTCODE" | $CC -o $TMPFILE -x c - -Wl,$i/libresolv.a >/dev/null 2>/dev/null
316                        if [ "$?" = "0" ]; then
317                                echo 'EFLAGS+='$i'/libresolv.a' >> Makefile.settings
318                                ret=0
319                        fi
320                fi
321        done
322
323        rm -f $TMPFILE
324        return $ret
325}
326
327if [ "$ssl" = "auto" ]; then
328        detect_gnutls
329        if [ "$ret" = "0" ]; then
330                detect_nss
331        fi
332elif [ "$ssl" = "gnutls" ]; then
333        detect_gnutls
334elif [ "$ssl" = "nss" ]; then
335        detect_nss
336elif [ "$ssl" = "sspi" ]; then
337        echo
338elif [ "$ssl" = "openssl" ]; then
339        echo
340        echo 'No detection code exists for OpenSSL. Make sure that you have a complete'
341        echo 'install of OpenSSL (including devel/header files) before reporting'
342        echo 'compilation problems.'
343        echo
344        echo 'Also, keep in mind that the OpenSSL is, according to some people, not'
345        echo 'completely GPL-compatible. Using GnuTLS or NSS is recommended and better'
346        echo 'supported by us. However, on many BSD machines, OpenSSL can be considered'
347        echo 'part of the operating system, which makes it GPL-compatible.'
348        echo
349        echo 'For more info, see: http://www.openssl.org/support/faq.html#LEGAL2'
350        echo '                    http://www.gnome.org/~markmc/openssl-and-the-gpl.html'
351        echo
352        echo 'Please note that distributing a BitlBee binary which links to OpenSSL is'
353        echo 'probably illegal. If you want to create and distribute a binary BitlBee'
354        echo 'package, you really should use GnuTLS or NSS instead.'
355        echo
356        echo 'Also, the OpenSSL license requires us to say this:'
357        echo ' *    "This product includes software developed by the OpenSSL Project'
358        echo ' *    for use in the OpenSSL Toolkit. (http://www.openssl.org/)"'
359       
360        echo 'EFLAGS+=-lssl -lcrypto' >> Makefile.settings
361       
362        ret=1
363elif [ "$ssl" = "bogus" ]; then
364        echo
365        echo 'Using bogus SSL code. This means some features will not work properly.'
366       
367        ## Yes, you, at the console! How can you authenticate if you don't have any SSL!?
368        if [ "$msn" = "1" -o "$yahoo" = "1" ]; then
369                echo
370                echo 'WARNING: The MSN and Yahoo! modules will not work without SSL. Disabling.'
371                msn=0
372                yahoo=0
373        fi
374       
375        ret=1
376else
377        echo
378        echo 'ERROR: Unknown SSL library specified.'
379        exit 1
380fi
381
382if [ "$ret" = "0" ]; then
383        echo
384        echo 'ERROR: Could not find a suitable SSL library (GnuTLS, libnss or OpenSSL).'
385        echo '       Please note that this script doesn'\''t have detection code for OpenSSL,'
386        echo '       so if you want to use that, you have to select it by hand. If you don'\''t'
387        echo '       need SSL support, you can select the "bogus" SSL library. (--ssl=bogus)'
388       
389        exit 1
390fi;
391
392echo 'SSL_CLIENT=ssl_'$ssl'.o' >> Makefile.settings
393
394if detect_resolv_dynamic || detect_resolv_static; then
395        echo '#define HAVE_RESOLV_A' >> config.h
396fi
397
398STORAGES="xml"
399
400if [ "$ldap" = "auto" ]; then
401        detect_ldap
402fi
403
404if [ "$ldap" = 0 ]; then
405        echo "#undef WITH_LDAP" >> config.h
406elif [ "$ldap" = 1 ]; then
407        echo
408        echo 'LDAP support is a work in progress and does NOT work AT ALL right now.'
409        echo
410        exit 1
411       
412        echo "#define WITH_LDAP 1" >> config.h
413        STORAGES="$STORAGES ldap"
414fi
415
416for i in $STORAGES; do
417        STORAGE_OBJS="$STORAGE_OBJS storage_$i.o"
418done
419echo "STORAGE_OBJS="$STORAGE_OBJS >> Makefile.settings
420
421if [ "$strip" = 0 ]; then
422        echo "STRIP=\# skip strip" >> Makefile.settings;
423else
424        if [ "$debug" = 1 ]; then
425                echo
426                echo 'Stripping binaries does not make sense when debugging. Stripping disabled.'
427                echo 'STRIP=\# skip strip' >> Makefile.settings
428                strip=0;
429        elif [ -n "$STRIP" ]; then
430                echo "STRIP=$STRIP" >> Makefile.settings;
431        elif type strip > /dev/null 2> /dev/null; then
432                echo "STRIP=strip" >> Makefile.settings;
433        else
434                echo
435                echo 'No strip utility found, cannot remove unnecessary parts from executable.'
436                echo 'STRIP=\# skip strip' >> Makefile.settings
437                strip=0;
438        fi;
439fi
440
441if [ "$gcov" = "1" ]; then
442        echo "CFLAGS+=--coverage" >> Makefile.settings
443        echo "EFLAGS+=--coverage" >> Makefile.settings
444fi
445
446if [ "$plugins" = 0 ]; then
447        echo '#undef WITH_PLUGINS' >> config.h
448else
449        echo '#define WITH_PLUGINS' >> config.h
450fi
451
452if [ ! -e doc/user-guide/help.txt ] && ! type xmlto > /dev/null 2> /dev/null; then
453        echo
454        echo 'WARNING: Building from an unreleased source tree without prebuilt helpfile.'
455        echo 'Install xmlto if you want online help to work.'
456fi
457
458echo
459if [ -z "$BITLBEE_VERSION" -a -d .bzr ] && type bzr > /dev/null 2> /dev/null; then
460        nick=`bzr nick`
461        if [ -n "$nick" -a "$nick" != "bitlbee" ]; then
462                nick="-$nick"
463        else
464                nick=""
465        fi
466        rev=`bzr revno`
467        echo 'Using bzr revision #'$rev' as version number'
468        BITLBEE_VERSION=\"bzr$nick-$rev\"
469fi
470
471if [ -n "$BITLBEE_VERSION" ]; then
472        echo 'Spoofing version number: '$BITLBEE_VERSION
473        echo '#undef BITLBEE_VERSION' >> config.h
474        echo '#define BITLBEE_VERSION '$BITLBEE_VERSION >> config.h
475        echo
476fi
477
478cat <<EOF>bitlbee.pc
479prefix=$prefix
480includedir=$includedir
481
482Name: bitlbee
483Description: IRC to IM gateway
484Requires: glib-2.0
485Version: $BITLBEE_VERSION
486Libs:
487Cflags: -I\${includedir}
488
489EOF
490
491protocols=''
492protoobjs=''
493
494if [ "$msn" = 0 ]; then
495        echo '#undef WITH_MSN' >> config.h
496else
497        echo '#define WITH_MSN' >> config.h
498        protocols=$protocols'msn '
499        protoobjs=$protoobjs'msn_mod.o '
500fi
501
502if [ "$jabber" = 0 ]; then
503        echo '#undef WITH_JABBER' >> config.h
504else
505        echo '#define WITH_JABBER' >> config.h
506        protocols=$protocols'jabber '
507        protoobjs=$protoobjs'jabber_mod.o '
508fi
509
510if [ "$oscar" = 0 ]; then
511        echo '#undef WITH_OSCAR' >> config.h
512else
513        echo '#define WITH_OSCAR' >> config.h
514        protocols=$protocols'oscar '
515        protoobjs=$protoobjs'oscar_mod.o '
516fi
517
518if [ "$yahoo" = 0 ]; then
519        echo '#undef WITH_YAHOO' >> config.h
520else
521        echo '#define WITH_YAHOO' >> config.h
522        protocols=$protocols'yahoo '
523        protoobjs=$protoobjs'yahoo_mod.o '
524fi
525
526if [ "$protocols" = "PROTOCOLS = " ]; then
527        echo "Warning: You haven't selected any communication protocol to compile!"
528        echo "         BitlBee will run, but you will be unable to connect to IM servers!"
529fi
530
531echo "PROTOCOLS = $protocols" >> Makefile.settings
532echo "PROTOOBJS = $protoobjs" >> Makefile.settings
533
534echo Architecture: $arch
535case "$arch" in
536Linux )
537;;
538GNU/* )
539;;
540*BSD )
541;;
542Darwin )
543        echo 'STRIP=\# skip strip' >> Makefile.settings
544;;
545IRIX )
546;;
547SunOS )
548        echo 'EFLAGS+=-lresolv -lnsl -lsocket' >> Makefile.settings
549        echo 'STRIP=\# skip strip' >> Makefile.settings
550;;
551AIX )
552        echo 'EFLAGS+=-Wl,-brtl' >> Makefile.settings
553;;
554CYGWIN* )
555        echo 'Cygwin is not officially supported.'
556;;
557Windows )
558;;
559* )
560        echo 'We haven'\''t tested BitlBee on many platforms yet, yours is untested. YMMV.'
561        echo 'Please report any problems at http://bugs.bitlbee.org/.'
562;;
563esac
564
565if [ -n "$target" ]; then
566        echo "Cross-compiling for: $target"
567fi
568
569echo
570echo 'Configuration done:'
571
572if [ "$debug" = "1" ]; then
573        echo '  Debugging enabled.'
574else
575        echo '  Debugging disabled.'
576fi
577
578if [ "$strip" = "1" ]; then
579        echo '  Binary stripping enabled.'
580else
581        echo '  Binary stripping disabled.'
582fi
583
584echo '  Using event handler: '$events
585echo '  Using SSL library: '$ssl
586echo '  Building with these storage backends: '$STORAGES
587
588if [ -n "$protocols" ]; then
589        echo '  Building with these protocols:' $protocols
590else
591        echo '  Building without IM-protocol support. We wish you a lot of fun...'
592fi
Note: See TracBrowser for help on using the repository browser.